C To obtain the spacing of planes, when the Miller indices are not
C  those which are systematically absent. The calculation is
C  interactive, and ordered lists of d-spacings available
C
      SUBROUTINE MAP_CRYSTAL_DSPACE(G,JTYPE,II1,JYES,AH,AK,AL,
     &SPCE,MAGN,JK)
      IMPLICIT NONE
      REAL G(9),F(9),AAA(3000),SPCE(400),MAGN(400)
      REAL AH(400),AK(400),AL(400),H,K,L,AD
      INTEGER JTYPE,II1,JYES,JLOG,JK,I1,I2,I3,IN,II2,JI
C
C
C The metric tensor F converts the components from reciprocal to
C  real space. 
C The metric tensor G converts the components from real to reciprocal
C  space, and G is the inverse of F and vice-versa.
C AAA is the matrix of d-spacings
C
C
C
      JK=0
      II1=II1+1
C
      CALL MAP_UTIL_INVERS(F,G)
C
C Generate a list of spacings with systematically varying Miller indices
      II2=0
      DO 10 I1=1,II1
        H=I1-1
         DO 20 I2=1,II1
          K=I2-1
           DO 30 I3=1,II1
            L=I3-1
            IF(H.EQ.0 .AND. K.EQ.0 .AND. L.EQ.0)GOTO 30
            CALL MAP_CRYSTAL_DSP(F,H,K,L,JTYPE,JLOG,AD)
            IF(JLOG .EQ. 1)GOTO 30
            II2=II2+1
            AAA(II2)=AD
              DO 40  JI=1,II2-1
C              Eliminate planes with similar spacings
               IF(AD .EQ. AAA(JI))GOTO 30
 40           CONTINUE
            IN=INT(H*H+K*K+L*L)
            JK=JK+1
            AH(JK)=H
            AK(JK)=K
            AL(JK)=L
            SPCE(JK)=AD
            MAGN(JK)=IN
 30        CONTINUE
 20      CONTINUE
 10    CONTINUE
C
           IF(JYES .EQ. 0)GOTO 100
C
      CALL MAP_UTIL_SORT2(JK,SPCE,MAGN)
C
C
 100    RETURN
        END
